<template>
    <modal name="choice-city"
           class="arcticmodal-container full-viewport"
           width="600"
           height="auto"
           adaptive
           @beforeOpen="$helpers.noscroll(true)"
           @beforeClose="$helpers.noscroll(false);search = '';">
        <div class="container m-header ">
            <div class="box-modal_close arcticmodal-close" @click="$modal.hide('choice-city');"></div>
            <div class="row">
                <div class="column">
                    <h3>Выберите ваш город</h3>
                </div>
            </div>
        </div>
        <div class="container  my-accounts-modal1 city-modal  feedback-block">
            <div class="search-block">
                <input type="text" name="search" placeholder="Поиск вашего города..." v-model="search" class="search"/>
                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" class="location" @click="getUserLocation" title="Поиск рядом со мной">
                    <path d="M 12 2.0097656 C 8.144 2.0097656 5.0078125 5.1479063 5.0078125 9.0039062 C 5.0078125 13.486906 10.974516 20.769172 11.228516 21.076172 L 12 22.011719 L 12.771484 21.076172 C 13.025484 20.768172 18.992188 13.486906 18.992188 9.0039062 C 18.992187 5.1469062 15.856 2.0097656 12 2.0097656 z M 12 4.0097656 C 14.753 4.0097656 16.992188 6.2509062 16.992188 9.0039062 C 16.992187 11.708906 13.878 16.361172 12 18.826172 C 10.122 16.363172 7.0078125 11.712906 7.0078125 9.0039062 C 7.0078125 6.2509062 9.247 4.0097656 12 4.0097656 z M 12 6.5 C 10.619 6.5 9.5 7.619 9.5 9 C 9.5 10.381 10.619 11.5 12 11.5 C 13.381 11.5 14.5 10.381 14.5 9 C 14.5 7.619 13.381 6.5 12 6.5 z"></path>
                </svg>
            </div>
            <div class="row" v-if="!search">
                <div class="columns three" v-for="(i, column) in 4">
                    <ul>
                        <li v-for="(city, index) in cities(i)">
                            <a @click.prevent="$emit('choice', city)"
                               v-if="!isSelected(city)"
                               href="#" >
                                {{city.city}}
                            </a>
                            <span v-else>{{city.city}}</span>
                        </li>
                    </ul>
                </div>
            </div>
            <div v-else>
                <div class="columns twelwe" v-if="!loading">
                    <ul>
                        <li  v-for="sug in suggestions" :key="sug.city_with_type" @click="setFias(sug)">
                            <span class="link">{{sug.city_with_type || sug.region_with_type}}</span>
                        </li>
                    </ul>
                </div>
                <loader ref="loader" v-else
                        v-bind="{
                      name: 'citySearch',
                      isShow: loading,
                      isFixed: false,
                      waitingTitle: 'Ищем город...',
                      caption: '',
                  }"
                        style="z-index: 502"
                />
            </div>
        </div>
    </modal>
</template>

<script>
    import debounce from 'lodash/debounce';
    import axios from 'axios';
    import Loader from '@/components/Loader';
    import {EventBus} from '@/utils/event-bus'

    let cancelToken;
    let source;

    export default {
        name: 'CityChoiceModal',
        components: {
            Loader
        },
        data() {
            return {
                search: '',
                suggestionsData: [],
                loading: false,
                citiesData:[{"city":"Москва","city_fias_id":"0c5b2444-70a0-4932-980c-b4dc0d3f02b5"},{"city":"Санкт-Петербург","city_fias_id":"c2deb16a-0330-4f05-821f-1d09c93331e6"},{"city":"Абакан","city_fias_id":"42a02e11-a337-4d50-8596-fc76dae7c62a"},{"city":"Армавир","city_fias_id":"fc9c55d0-c66e-455e-8034-b0944b025c38"},{"city":"Архангельск","city_fias_id":"06814fb6-0dc3-4bec-ba20-11f894a0faf5"},{"city":"Барнаул","city_fias_id":"d13945a8-7017-46ab-b1e6-ede1e89317ad"},{"city":"Белгород","city_fias_id":"02e9c019-ab4d-4fa0-928e-d6c0a41dc256"},{"city":"Бийск","city_fias_id":"52f876f6-cb1d-4f23-a22f-b692609fc1e0"},{"city":"Благовещенск","city_fias_id":"8f41253d-6e3b-48a9-842a-25ba894bd093"},{"city":"Братск","city_fias_id":"bdf6b629-b33e-4cfa-b4b2-7f693e1d821c"},{"city":"Брянск","city_fias_id":"414b71cf-921e-4bfc-b6e0-f7395d16aaef"},{"city":"Великие Луки","city_fias_id":"ca091eae-2c39-4730-b57d-b2fa570f71cb"},{"city":"Великий Новгород","city_fias_id":"8d0a05bf-3b8a-43e9-ac26-7ce61d7c4560"},{"city":"Владивосток","city_fias_id":"7b6de6a5-86d0-4735-b11a-499081111af8"},{"city":"Владикавказ","city_fias_id":"20ea2341-4f49-4c5c-a9dc-a54688c8cc61"},{"city":"Владимир","city_fias_id":"f66a00e6-179e-4de9-8ecb-78b0277c9f10"},{"city":"Волгоград","city_fias_id":"a52b7389-0cfe-46fb-ae15-298652a64cf8"},{"city":"Вологда","city_fias_id":"023484a5-f98d-4849-82e1-b7e0444b54ef"},{"city":"Воронеж","city_fias_id":"5bf5ddff-6353-4a3d-80c4-6fb27f00c6c1"},{"city":"Грозный","city_fias_id":"a2072dc5-45be-4db3-ab13-10784ba8b2ae"},{"city":"Дзержинск","city_fias_id":"1d5a97d5-9bdf-44c9-ac42-e201833e7f28"},{"city":"Екатеринбург","city_fias_id":"2763c110-cb8b-416a-9dac-ad28a55b4402"},{"city":"Иваново","city_fias_id":"40c6863e-2a5f-4033-a377-3416533948bd"},{"city":"Ижевск","city_fias_id":"deb1d05a-71ce-40d1-b726-6ba85d70d58f"},{"city":"Иркутск","city_fias_id":"8eeed222-72e7-47c3-ab3a-9a553c31cf72"},{"city":"Йошкар-Ола","city_fias_id":"0648e41c-a09b-4eac-91cd-8cf61b9ccb7b"},{"city":"Казань","city_fias_id":"93b3df57-4c89-44df-ac42-96f05e9cd3b9"},{"city":"Калуга","city_fias_id":"b502ae45-897e-4b6f-9776-6ff49740b537"},{"city":"Кемерово","city_fias_id":"94bb19a3-c1fa-410b-8651-ac1bf7c050cd"},{"city":"Киров","city_fias_id":"452a2ddf-88a1-4e35-8d8d-8635493768d4"},{"city":"Кострома","city_fias_id":"14c73394-b886-40a9-9e5c-547cfd4d6aad"},{"city":"Краснодар","city_fias_id":"7dfa745e-aa19-4688-b121-b655c11e482f"},{"city":"Красноярск","city_fias_id":"9b968c73-f4d4-4012-8da8-3dacd4d4c1bd"},{"city":"Курган","city_fias_id":"3bbda77d-ba3f-4457-9d44-c440815cda89"},{"city":"Курск","city_fias_id":"d790c72e-479b-4da2-90d7-842b1712a71c"},{"city":"Липецк","city_fias_id":"eacb5f15-1a2e-432e-904a-ca56bd635f1b"},{"city":"Магнитогорск","city_fias_id":"988157bf-d6d5-4c2a-80ec-4ad531eea056"},{"city":"Санкт-Петербург","city_fias_id":"c2deb16a-0330-4f05-821f-1d09c93331e6"},{"city":"Мурманск","city_fias_id":"b7127184-ead6-422b-b7cf-4fc7725b47a5"},{"city":"Набережные Челны","city_fias_id":"748d7afa-7407-4876-9f40-764ecdd09bbd"},{"city":"Назрань","city_fias_id":"815566a1-04ea-44a9-b34b-25b70ac9aa9a"},{"city":"Нальчик","city_fias_id":"913a82e3-b671-43d5-97b4-8a08b8ee2d28"},{"city":"Нижний Новгород","city_fias_id":"555e7d61-d9a7-4ba6-9770-6caa8198c483"},{"city":"Нижний Тагил","city_fias_id":"cc73d6af-6e2e-4a1f-be8e-682c289b0b57"},{"city":"Новокузнецк","city_fias_id":"b28b6f6f-1435-444e-95a6-68c499b0d27a"},{"city":"Новороссийск","city_fias_id":"16ac039a-5257-4715-a8c5-d6bd9e617b53"},{"city":"Новосибирск","city_fias_id":"8dea00e3-9aab-4d8e-887c-ef2aaa546456"},{"city":"Новочеркасск","city_fias_id":"28bafcb3-92b2-445b-9443-a341be73fdb9"},{"city":"Норильск","city_fias_id":"d301a980-4a45-4066-9a20-4e783856a562"},{"city":"Ноябрьск","city_fias_id":"131c6e49-9bc5-484d-b65a-ee7f5d250418"},{"city":"Омск","city_fias_id":"140e31da-27bf-4519-9ea0-6185d681d44e"},{"city":"Оренбург","city_fias_id":"dce97bff-deb2-4fd9-9aec-4f4327bbf89b"},{"city":"Пенза","city_fias_id":"ff3292b1-a1d2-47d4-b35b-ac06b50555cc"},{"city":"Пермь","city_fias_id":"a309e4ce-2f36-4106-b1ca-53e0f48a6d95"},{"city":"Петрозаводск","city_fias_id":"ccc34487-8fd4-4e71-b032-f4e6c82fb354"},{"city":"Петропавловск-Камчатский","city_fias_id":"0b3f0723-5fe0-4c23-af44-8082166c6d2e"},{"city":"Псков","city_fias_id":"2858811e-448a-482e-9863-e03bf06bb5d4"},{"city":"Пятигорск","city_fias_id":"9b0efbd0-22bb-400d-86db-ddc69b9939d9"},{"city":"Ростов-на-Дону","city_fias_id":"c1cfe4b9-f7c2-423c-abfa-6ed1c05a15c5"},{"city":"Рязань","city_fias_id":"86e5bae4-ef58-4031-b34f-5e9ff914cd55"},{"city":"Самара","city_fias_id":"bb035cc3-1dc2-4627-9d25-a1bf2d4b936b"},{"city":"Саранск","city_fias_id":"1ccfdc3c-be0f-4e42-ab4d-98f90de972d9"},{"city":"Саратов","city_fias_id":"bf465fda-7834-47d5-986b-ccdb584a85a6"},{"city":"Северодвинск","city_fias_id":"32747c72-c08b-4440-b340-91f48d72f9db"},{"city":"Смоленск","city_fias_id":"d414a2e8-9e1e-48c1-94a4-7308d5608177"},{"city":"Сочи","city_fias_id":"79da737a-603b-4c19-9b54-9114c96fb912"},{"city":"Ставрополь","city_fias_id":"2a1c7bdb-05ea-492f-9e1c-b3999f79dcbc"},{"city":"Старый Оскол","city_fias_id":"9f5e86b1-b893-43dc-9dd4-ac66573b17d1"},{"city":"Сургут","city_fias_id":"f1eb1809-47d4-4f0b-9a74-fa416e9d3df2"},{"city":"Сызрань","city_fias_id":"e9e684ce-7d60-4480-ba14-ca6da658188b"},{"city":"Сыктывкар","city_fias_id":"d2944a73-daf4-4a08-9b34-d9b0af7785a1"},{"city":"Тамбов","city_fias_id":"ea2a1270-1e19-4224-b1a0-4228b9de3c7a"},{"city":"Тверь","city_fias_id":"c52ea942-555e-45c6-9751-58897717b02f"},{"city":"Тольятти","city_fias_id":"242e87c1-584d-4360-8c4c-aae2fe90048e"},{"city":"Томск","city_fias_id":"e3b0eae8-a4ce-4779-ae04-5c0797de66be"},{"city":"Тула","city_fias_id":"b2601b18-6da2-4789-9fbe-800dde06a2bb"},{"city":"Тюмень","city_fias_id":"9ae64229-9f7b-4149-b27a-d1f6ec74b5ce"},{"city":"Улан-Удэ","city_fias_id":"9fdcc25f-a3d0-4f28-8b61-40648d099065"},{"city":"Ульяновск","city_fias_id":"bebfd75d-a0da-4bf9-8307-2e2c85eac463"},{"city":"Уфа","city_fias_id":"7339e834-2cb4-4734-a4c7-1fca2c66e562"},{"city":"Хабаровск","city_fias_id":"a4859da8-9977-4b62-8436-4e1b98c5d13f"},{"city":"Чебоксары","city_fias_id":"dd8caeab-c685-4f2a-bf5f-550aca1bbc48"},{"city":"Челябинск","city_fias_id":"a376e68d-724a-4472-be7c-891bdb09ae32"},{"city":"Череповец","city_fias_id":"b4c30848-5181-44b4-88fa-456e1c4aeb0f"},{"city":"Чита","city_fias_id":"2d9abaa6-85a6-4f1f-a1bd-14b76ec17d9c"},{"city":"Южно-Сахалинск","city_fias_id":"44388ad0-06aa-49b0-bbf9-1704629d1d68"},{"city":"Якутск","city_fias_id":"884c84a2-0141-4652-962d-8a92989b88f7"},{"city":"Ярославль","city_fias_id":"6b1bab7d-ee45-4168-a2a6-4ce2880d90d3"}]
            };
        },
        computed: {
            suggestions () {
                const cache = [];
                return this.suggestionsData.filter((row) => {
                    console.log(row.data);
                    if(cache.includes(row.data.city_with_type) || cache.includes(row.data.region_with_type)) return false

                    if(!row.data.city_with_type && !row.data.region_with_type) return false;

                    cache.push(row.data.city_with_type || row.data.region_with_type);

                    return row.data.city_with_type || row.data.region_with_type;
                }).map((row) => {
                    return row.data;
                })
            }
        },
        watch: {
            search: debounce(function(query) {
                if(source) {
                    source.cancel('test');
                    source = cancelToken.source();
                } else {
                    source = cancelToken.source();
                }

                this.loading = true;
                axios.post('https://api.webbankir.com/v3/suggest/address?', {
                    query: query
                }, {
                    cancelToken: source.token
                }).then(({data}) => {
                    console.log(data);
                    this.suggestionsData = data.suggestions;
                    console.log('_suggestions', this._suggestions);
                }).catch((e) => {

                }).finally(() => {
                    source = null;
                    this.loading = false;
                })
            }, 500)
        },

        created () {
            cancelToken = axios.CancelToken;
            source = cancelToken.source();
            //
            // const cities = ["Москва", "Санкт-Петербург", "Абакан", "Армавир", "Архангельск", "Барнаул", "Белгород", "Бийск", "Благовещенск", "Братск", "Брянск", "Великие Луки", "Великий Новгород", "Владивосток", "Владикавказ", "Владимир", "Волгоград", "Вологда", "Воронеж", "Грозный", "Дзержинск", "Екатеринбург", "Иваново", "Ижевск", "Иркутск", "Йошкар-Ола", "Казань", "Калуга", "Кемерово", "Киров", "Кострома", "Краснодар", "Красноярск", "Курган", "Курск", "Липецк", "Магнитогорск", "Мончегорск", "Мурманск", "Набережные Челны", "Назрань", "Нальчик", "Нижний Новгород", "Нижний Тагил", "Новокузнецк", "Новороссийск", "Новосибирск", "Новочеркасск", "Норильск", "Ноябрьск", "Омск", "Оренбург", "Пенза", "Пермь", "Петрозаводск", "Петропавловск-Камчатский", "Псков", "Пятигорск", "Ростов-на-Дону", "Рязань", "Самара", "Саранск", "Саратов", "Северодвинск", "Смоленск", "Сочи", "Ставрополь", "Старый Оскол", "Сургут", "Сызрань", "Сыктывкар", "Тамбов", "Тверь", "Тольятти", "Томск", "Тула", "Тюмень", "Улан-Удэ", "Ульяновск", "Уфа", "Хабаровск", "Чебоксары", "Челябинск", "Череповец", "Чита", "Южно-Сахалинск", "Якутск", "Ярославль"];
            // let i = 0;
            //
            // const c = [];
            // const get = () => {
            //     const  getFias = async  () =>  {
            //         return this.$backend.postData('address', {
            //             query: 'г ' + cities[i]
            //         }, 'https://api.webbankir.com/v3/suggest/').then(({data}) => {
            //             c.push({
            //                 city: data.suggestions[0]?.data.city,
            //                 city_fias_id: data.suggestions[0]?.data.city_fias_id,
            //             })
            //             return Promise.resolve();
            //         })
            //     }
            //
            //     getFias().then(() => {
            //         i++;
            //         if(cities[i]) {
            //             get();
            //         } else {
            //             console.log(JSON.stringify(c))
            //         }
            //     });
            //
            // }
            //
            // get();






        },

        methods: {

            isSelected (city) {
                if (['region_fias', 'geo'].includes(this.$installment.geo_type)) return false;

                return this.$installment.geo_fias_id === city.city_fias_id;
            },

            getUserLocation () {
                navigator.geolocation.getCurrentPosition((position)  => {
                    this.$store.commit('SET_POS_LOCATION', {lat: position.coords.latitude, lon: position.coords.longitude});
                    this.$modal.hide('choice-city');
                }, (e) => {
                    if (document.location.protocol !== 'https') {
                        this.$toastr.warning('Это действие доступно только в защищенном режиме соединения.', 'Ошибка');
                    } else {
                        this.$toastr.warning('Не удалось получить ваше местоположение. Возможно, вы запретили это действие для Webbankir.', 'Ошибка');
                    }
                });
            },
            cities (column) {
                const array = [];

                if(column === 1 && this.$installment.geo_type === 'city_fias') {
                    // array.push({
                    //     city: this.$installment.city,
                    //     city_fias_id: this.$installment.city_fias_id,
                    // })
                }

                for(let i = 0; i < this.citiesData.length; i ++ ){
                    if (i % 4 === column -1) {
                        if (this.citiesData[i].city_fias_id !== this.$installment.city_fias_id && !array.find(r => r.city === this.citiesData[i].city)) {
                            array.push(this.citiesData[i]);
                        }
                    }
                }

                return array;
            },
            setFias(sug) {
                console.log(sug);
                this.$modal.hide('choice-city');
                this.$store.commit('SET_POS_FIAS', {
                    city: sug.city,
                    region: sug.city ? null : sug.region_with_type,
                    fias_id: sug.city_fias_id || sug.region_fias_id
                });

            }
        }
    };
</script>

<style scoped>

</style>
